/***************************************************************************
                          kmichannellist.cpp  -  description
                             -------------------
    begin                : Don Aug 8 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kmichannellist.h"

KMIChannelList::KMIChannelList(QWidget *parent, const char *name ) : channelList(parent,name) {
  setCaption(i18n("Channel List"));
  setTabCaption(i18n("Channel List"));
  setMDICaption(i18n("Channel List"));
  countChannels=0;
}
KMIChannelList::~KMIChannelList(){
}
/** No descriptions */
void KMIChannelList::addChannel(const QString &name,const QString &nou,const QString &desc){
  lviewChannelList->insertItem(new QListViewItem(lviewChannelList,name,nou,desc));
  countChannels++;
  labelNoOfChannels->setText(QString("%1").arg(countChannels));
}
/** No descriptions */
void KMIChannelList::slotBtnJoin(){
  if (lviewChannelList->selectedItem()!=0) {
    sendInput("JOIN "+lviewChannelList->selectedItem()->text(0)+"\n",this);
  }
}
/** No descriptions */
void KMIChannelList::slotBtnRefresh(){
  lviewChannelList->clear();
  sendInput("LIST\n",this);
}

/** No descriptions */
void KMIChannelList::slotBtnWho(){
  if (lviewChannelList->selectedItem()!=0) {
    sendInput("WHO "+lviewChannelList->selectedItem()->text(0)+"\n",this);
  }
}
/** No descriptions */
void KMIChannelList::slotBtnClose(){
  close();
}
/** No descriptions */
void KMIChannelList::slotChanneListClicked(QListViewItem *item){
  if (item!=0) {
    activateButtons();
  } else {
    deactivateButtons();
  } 
}
/** No descriptions */
void KMIChannelList::activateButtons(){
  btnJoin->setEnabled(true);
  btnWho->setEnabled(true);
}
/** No descriptions */
void KMIChannelList::deactivateButtons(){
  btnJoin->setEnabled(false);
  btnWho->setEnabled(false);
}
