/***************************************************************************
                          kmichannelwindow.cpp  -  description
                             -------------------
    begin                : Son Jun 16 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "../ircgui/kmichannelwindow.h"
#include <qevent.h>

KMIChannelWindow::KMIChannelWindow(const QString &title,QWidget *parent, const char *name,bool channel,bool privateMsg,KMIConfig *config) : channelWindow(parent,name) {
  setCaption(title);
  setTabCaption(title);
  setMDICaption(title);
  setParted(false);
  if (channel && !privateMsg) {
    isServerWindow=false;
    isPrivateMessageWindow=false;
    activateChannelSpecials();
  } else if (!channel && !privateMsg){
    isServerWindow=true;
    isPrivateMessageWindow=false;
    deactivateChannelSpecials();
  } else if (!channel && privateMsg) {
    isServerWindow=false;
    isPrivateMessageWindow=true;
    deactivateChannelSpecials();
  }
  users=0;
  operators=0;
  voices=0;
  channelName=title;
  connect(entryInputLine,SIGNAL(returnPressed()),this,SLOT(slotInputReturnPressed()));
  connect(this,SIGNAL(activated(QextMdiChildView *)),this,SLOT(viewActivated(QextMdiChildView *)));
  connect(listUser,SIGNAL(rightButtonPressed(QListBoxItem *,const QPoint &)),this,SLOT(slotRightButtonPressed(QListBoxItem *,const QPoint &)));
  KIconLoader *iconLoader=new KIconLoader("kmyirc");
  picNoStatus=iconLoader->loadIcon("nostatus",KIcon::Small);
  picVoice=iconLoader->loadIcon("voice",KIcon::Small);
  picOper=iconLoader->loadIcon("operator",KIcon::Small);
  entryInputLine->setFocus();
  largestNickInPixel=0;
  // entryInputLine->grabKeyboard();
 cfg=config;
}
KMIChannelWindow::~KMIChannelWindow(){
}
/** No descriptions */
void KMIChannelWindow::output(const QString &out){
  qDebug("In Out "+ out);
  QString tt=out;
  tt=tt.replace(QRegExp("\n"),"");
  //outputText->append(out);
  outputText->append(tt);
 // outputText->scrollToBottom();
  // outputText->moveCursor(QTextEdit::MoveEnd);
  // QKeyEvent *tt=new QKeyEvent(QEvent::KeyPress,Qt::Key_End
  //entryInputLine->setFocus();
}
/** No descriptions */
void KMIChannelWindow::slotInputReturnPressed(){
  if (!entryInputLine->text().isEmpty()) {
    sendInput(entryInputLine->text(),this);
    entryInputLine->clear();
    // outputText->scrollToBottom();
  }
}
/** No descriptions */
void KMIChannelWindow::activateChannelSpecials(){
    labelNoOfOperator->show();
    labelNoOfVoices->show();
    labelNoOfUsers->show();
    listUser->show();
    
    listUser->show();
    btnUser1->show();
    btnUser2->show();
    btnUser3->show();
    btnUser4->show();
    btnUser5->show();
    btnUser6->show();
    btnUser7->show();
    btnUser8->show();
    modeBtnN->show();
    modeBtnM->show();
    modeBtnT->show();
    modeBtnS->show();
    modeBtnI->show();
    modeBtnP->show();
    modeBtnK->show();
    modeBtnL->show();
    modeBtnA->show();
    modeBtnQ->show();
    modeBtnR->show();
    entryChannelKey->show();
    btnBanMasks->show();
    entryChannelLimit->show();
    labelTopic->show();
    entryTopic->show();    
    listUser->setEnabled(true);
    btnUser1->setEnabled(true);
    btnUser2->setEnabled(true);
    btnUser3->setEnabled(true);
    btnUser4->setEnabled(true);
    btnUser5->setEnabled(true);
    btnUser6->setEnabled(true);
    btnUser7->setEnabled(true);
    btnUser8->setEnabled(true);
    modeBtnN->setEnabled(true);
    modeBtnM->setEnabled(true);
    modeBtnT->setEnabled(true);
    modeBtnS->setEnabled(true);
    modeBtnI->setEnabled(true);
    modeBtnP->setEnabled(true);
    modeBtnK->setEnabled(true);
    modeBtnL->setEnabled(true);
    modeBtnA->setEnabled(true);
    modeBtnQ->setEnabled(true);
    modeBtnR->setEnabled(true);
    
    entryChannelKey->setEnabled(true);
    btnBanMasks->setEnabled(true);
    entryChannelLimit->setEnabled(true);
    entryTopic->setEnabled(true);

}
/** No descriptions */
void KMIChannelWindow::deactivateChannelSpecials(){

    labelNoOfOperator->hide();
    labelNoOfVoices->hide();
    labelNoOfUsers->hide();
    listUser->hide();
    btnUser1->hide();
    btnUser2->hide();
    btnUser3->hide();
    btnUser4->hide();
    btnUser5->hide();
    btnUser6->hide();
    btnUser7->hide();
    btnUser8->hide();
    modeBtnN->hide();
    modeBtnM->hide();
    modeBtnT->hide();
    modeBtnS->hide();
    modeBtnI->hide();
    modeBtnP->hide();
    modeBtnK->hide();
    modeBtnL->hide();
    modeBtnA->hide();
    modeBtnQ->hide();
    modeBtnR->hide();
    
    entryChannelKey->hide();
    btnBanMasks->hide();
    entryChannelLimit->hide();
    labelTopic->hide();
    entryTopic->hide();
    listUser->setEnabled(false);
    btnUser1->setEnabled(false);
    btnUser2->setEnabled(false);
    btnUser3->setEnabled(false);
    btnUser4->setEnabled(false);
    btnUser5->setEnabled(false);
    btnUser6->setEnabled(false);
    btnUser7->setEnabled(false);
    btnUser8->setEnabled(false);
    modeBtnN->setEnabled(false);
    modeBtnM->setEnabled(false);
    modeBtnT->setEnabled(false);
    modeBtnS->setEnabled(false);
    modeBtnI->setEnabled(false);
    modeBtnP->setEnabled(false);
    modeBtnK->setEnabled(false);
    modeBtnL->setEnabled(false);
    modeBtnA->setEnabled(false);
    modeBtnQ->setEnabled(false);
    modeBtnR->setEnabled(false);
    
    entryChannelKey->setEnabled(false);
    btnBanMasks->setEnabled(false);
    entryChannelLimit->setEnabled(false);    
    entryTopic->setEnabled(false);
}
/** No descriptions */
const QString & KMIChannelWindow::getChannelName(){
  return channelName;
}
/** No descriptions */
void KMIChannelWindow::slotAddUserToList(const QString &user){
  if (user.contains("@")) {
    QString temp=user;
    temp.replace(temp.find("@"),1,"");
    listUser->insertItem(picOper,temp);
    operators++;
    users++;
  } else if (user.contains("+")) {
    QString temp=user;
    temp.replace(temp.find("+"),1,"");
    listUser->insertItem(picVoice,temp);
    voices++;
    users++;
  } else {
    listUser->insertItem(picNoStatus,user);
    users++;    
  }
  changeNumberLabels();
  // need to set the focus to the input line
  // entryInputLine->setFocus();
}/** No descriptions */
void KMIChannelWindow::addOp(const QString &user){
  QListBoxItem *temp=listUser->findItem(user);
  if (temp!=0) {
    if (temp->pixmap()->serialNumber()==picVoice.serialNumber()) {
      voices--;
    }
    listUser->changeItem(picOper,user,listUser->index(temp));
    operators++;
  }
  changeNumberLabels();
}
/** No descriptions */
void KMIChannelWindow::removeOp(const QString &user){
  QListBoxItem *temp=listUser->findItem(user);
  if (temp!=0) {
    listUser->changeItem(picNoStatus,user,listUser->index(temp));
    operators--;
  }
  changeNumberLabels();
}
/** No descriptions */
void KMIChannelWindow::addVoice(const QString &user){
  QListBoxItem *temp=listUser->findItem(user);
  if (temp!=0) {
    listUser->changeItem(picVoice,user,listUser->index(temp));
    voices++;
  }
  changeNumberLabels();
}
/** No descriptions */
void KMIChannelWindow::removeVoice(const QString &user){
  QListBoxItem *temp=listUser->findItem(user);
  if (temp!=0) {
    listUser->changeItem(picNoStatus,user,listUser->index(temp));
    voices--;
  }
  changeNumberLabels();
}
/** No descriptions */
void KMIChannelWindow::toggleModerate(bool on){
  modeBtnM->setOn(on);
}
/** No descriptions */
void KMIChannelWindow::toggleNoMessagesFromOutside(bool on){
  modeBtnN->setOn(on);
}
/** No descriptions */
void KMIChannelWindow::changeNickName(const QString &nickName){
  labelNick->setText(nickName);
  labelNick->resize(labelNick->sizeHint());
}
/** No descriptions */
void KMIChannelWindow::changeChannelNick(const QString &old,const QString &news){
  QListBoxItem *temp=listUser->findItem(old);
  if (temp!=0) {
    listUser->changeItem(*temp->pixmap(),news,listUser->index(temp));
  }
}
/** No descriptions */
bool KMIChannelWindow::isServer(){
  return isServerWindow;
}
/** No descriptions */
void KMIChannelWindow::removeUser(const QString &user){
	QListBoxItem *temp=listUser->findItem(user);
	if (temp!=0) {
		if (temp->pixmap()->serialNumber()==picOper.serialNumber()) {
			operators--;
			users--;
		} else if (temp->pixmap()->serialNumber()==picVoice.serialNumber()) {
			voices--;
			users--;
		} else {
			users--;
		}
		listUser->removeItem(listUser->index(temp));
  	}
  	changeNumberLabels();
}
/** No descriptions */
void KMIChannelWindow::changeNumberLabels(){
  labelNoOfOperator->setText(QString("O: %1").arg(operators,3));
  labelNoOfVoices->setText(QString("V: %1").arg(voices,3));
  labelNoOfUsers->setText(QString("U: %1").arg(users,3));
  listUser->sort();
}
/** No descriptions */
void KMIChannelWindow::setAnonymous(bool on){
  modeBtnA->setOn(on);
}
/** No descriptions */
void KMIChannelWindow::setTopicProtection(bool on){
  modeBtnT->setOn(on);
}
/** No descriptions */
void KMIChannelWindow::toggleInviteOnly(bool on){
  modeBtnI->setOn(on);
}
/** No descriptions */
void KMIChannelWindow::toggleQuite(bool on){
  modeBtnQ->setOn(on);
}
/** No descriptions */
void KMIChannelWindow::togglePrivate(bool on){
  modeBtnP->setOn(on);
}
/** No descriptions */
void KMIChannelWindow::toggleSecret(bool on){
  modeBtnS->setOn(on);
}
/** No descriptions */
void KMIChannelWindow::toggleServerReOp(bool on){
  modeBtnR->setOn(on);
}
/** No descriptions */
void KMIChannelWindow::toggleChannelLimit(bool on,const QString &limit){
  modeBtnL->setOn(on);
  entryChannelLimit->setText(limit);
}
/** No descriptions */
void KMIChannelWindow::toggleChannelKey(bool on,const QString &key){
  modeBtnK->setOn(on);
  entryChannelKey->setText(key);
}
/** No descriptions */
void KMIChannelWindow::setTopic(const QString &topic){
  entryTopic->setText(topic);
}

/** No descriptions */
QListBoxItem * KMIChannelWindow::findNickInChannel(const QString &nick){
  QListBoxItem *temp=listUser->findItem(nick);
  if (temp!=0) {
    return temp;
  } else {
    return 0;
  } 
}
/** No descriptions */
void KMIChannelWindow::slotRightButtonPressed(QListBoxItem *item,const QPoint &pt){
  uint counter=0;
  KPopupMenu *popup=new KPopupMenu(this,"popUp");
  for (s_aliasList *item1=cfg->getAliasList()->first();item1;item1=cfg->getAliasList()->next()) {
  	if (item1->ofType==1) {
  		popup->insertItem(item1->aliasName,100+counter,counter+1);
			counter++;
		}
  }
  uint menuitem=popup->exec(pt);
  if (menuitem!=-1) {
  	executeMultiCommands(popup->text(menuitem),item->text(),channelName);
 }
  delete popup;
}
#if QT_VERSION <= 304
// Workaround for a QTextEdit bug in QT <=3.0.4
// 3.0.5 is working correctly
/** No descriptions */
void KMIChannelWindow::showEvent(QShowEvent *e){
  QextMdiChildView::showEvent(e);
  outputText->scrollToBottom(); 
}
#endif

/** No descriptions */
void KMIChannelWindow::enterEvent ( QEvent *e ){
  QextMdiChildView::enterEvent(e);
  // entryInputLine->grabKeyboard();
}
/** No descriptions */
void KMIChannelWindow::leaveEvent ( QEvent * e){
  // entryInputLine->releaseKeyboard();
  QextMdiChildView::leaveEvent(e);
}
/** No descriptions */
void KMIChannelWindow::keyPressEvent(QKeyEvent *e){
  if (e->key()==Key_Backspace || e->ascii()>=32) {
    kapp->sendEvent(entryInputLine,e);
    e->accept();
  } else if (e->key()==Key_Enter || e->key()==Key_Return) {
   slotInputReturnPressed();
   e->accept();
  } else {
    QextMdiChildView::keyPressEvent(e);
  }
}
/** No descriptions */
bool KMIChannelWindow::isPrivateMsgWin(){
  return isPrivateMessageWindow;
}
/** No descriptions */
void KMIChannelWindow::viewActivated(QextMdiChildView *pWnd){
  outputText->scrollToBottom();
}

/** No descriptions */
void KMIChannelWindow::slotModeBtnT(){
  QString mode="t";
  if (modeBtnT->isOn()) {
    mode="-"+mode;
  } else {
    mode="+"+mode;
  }
  sendInput("/MODE "+caption()+" "+mode,this);
  sendInput("/MODE "+caption(),this);
}
/** No descriptions */
void KMIChannelWindow::slotModeBtnA(){
  QString mode="a";
  if (modeBtnT->isOn()) {
    mode="-"+mode;
  } else {
    mode="+"+mode;
  }
  sendInput("/MODE "+caption()+" "+mode,this);
  sendInput("/MODE "+caption(),this);
}
/** No descriptions */
void KMIChannelWindow::slotModeBtnN(){
  QString mode="n";
  if (modeBtnT->isOn()) {
    mode="-"+mode;
  } else {
    mode="+"+mode;
  }
  sendInput("/MODE "+caption()+" "+mode,this);
  sendInput("/MODE "+caption(),this);
}
/** No descriptions */
void KMIChannelWindow::slotModeBtnS(){
  QString mode="s";
  if (modeBtnT->isOn()) {
    mode="-"+mode;
  } else {
    mode="+"+mode;
  }
  sendInput("/MODE "+caption()+" "+mode,this);
  sendInput("/MODE "+caption(),this);
}
/** No descriptions */
void KMIChannelWindow::slotModeBtnI(){
  QString mode="i";
  if (modeBtnT->isOn()) {
    mode="-"+mode;
  } else {
    mode="+"+mode;
  }
  sendInput("/MODE "+caption()+" "+mode,this);
  sendInput("/MODE "+caption(),this);
}
/** No descriptions */
void KMIChannelWindow::slotModeBtnP(){
  QString mode="p";
  if (modeBtnT->isOn()) {
    mode="-"+mode;
  } else {
    mode="+"+mode;
  }
  sendInput("/MODE "+caption()+" "+mode,this);
  sendInput("/MODE "+caption(),this);
}
/** No descriptions */
void KMIChannelWindow::slotModeBtnM(){
  QString mode="m";
  if (modeBtnT->isOn()) {
    mode="-"+mode;
  } else {
    mode="+"+mode;
  }
  sendInput("/MODE "+caption()+" "+mode,this);
  sendInput("/MODE "+caption(),this);
}
/** No descriptions */
void KMIChannelWindow::slotModeBtnR(){
  QString mode="r";
  if (modeBtnT->isOn()) {
    mode="-"+mode;
  } else {
    mode="+"+mode;
  }
  sendInput("/MODE "+caption()+" "+mode,this);
  sendInput("/MODE "+caption(),this);
}
/** No descriptions */
void KMIChannelWindow::slotModeBtnQ(){
  QString mode="q";
  if (modeBtnT->isOn()) {
    mode="-"+mode;
  } else {
    mode="+"+mode;
  }
  sendInput("/MODE "+caption()+" "+mode,this);
  sendInput("/MODE "+caption(),this);
}
/** No descriptions */
void KMIChannelWindow::slotModeBtnK(){
  QString mode="k";
  if (modeBtnT->isOn()) {
    mode="-"+mode;
  } else {
    mode="+"+mode+" "+entryChannelKey->text();
  }
  sendInput("/MODE "+caption()+" "+mode,this);
  sendInput("/MODE "+caption(),this);
}
/** No descriptions */
void KMIChannelWindow::slotModeBtnL(){
  QString mode="l";
  if (modeBtnT->isOn()) {
    mode="-"+mode;
  } else {
    mode="+"+mode+" "+entryChannelLimit->text();
  }
  sendInput("/MODE "+caption()+" "+mode,this);
  sendInput("/MODE "+caption(),this);

}

void KMIChannelWindow::executeMultiCommands(const QString & commands, const QString & nickName, const QString & channelName)
{
	s_aliasList * alias=cfg->findAliasPtr(commands);
	
	QStringList strList=QStringList::split("\n",alias->aliasCommands);
	for ( QStringList::Iterator it = strList.begin(); it != strList.end(); ++it ) {
		QString tt=QString(*it);
        	tt.replace("%U",nickName);
		tt.replace("%C",channelName);
		qWarning("This is it: "+tt+"\n");
		sendInput(tt,this);
    	}
}

/*!
    \fn KMIChannelWindow::isParted()
 */
bool KMIChannelWindow::isParted()
{
	return parted;
}

/*!
    \fn KMIChannelWindow::setParted(bool)
 */
void KMIChannelWindow::setParted(bool yesno)
{
	parted=yesno;
}


