/***************************************************************************
                          kmichannelwindow.h  -  description
                             -------------------
    begin                : Son Jun 16 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMICHANNELWINDOW_H
#define KMICHANNELWINDOW_H

#include <qwidget.h>
// #include <qtextedit.h>
#include "../widgets/kmiwidgets/kmitextbrowser.h"
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qregexp.h>
// #include <qlistbox.h>
#include "../widgets/kmiwidgets/kmilistbox.h"
#include "../widgets/kmiwidgets/kmiuserlistviewitem.h"
#include <kiconloader.h>
#include <klocale.h>
#include <kpopupmenu.h>
#include "../widgets/kmiwidgets/kmiinputline.h"
#include "../ircgui/channelWindow.h"
#include "../logic/kmiconfig.h"
#include <kapp.h>

/**
  *@author Stephan Hermann
  */

class KMIChannelWindow : public channelWindow  {
   Q_OBJECT
public: 
	KMIChannelWindow(const QString &title="Untitled",QWidget *parent=0, const char *name=0,bool channel=true,bool privateMsg=false,KMIConfig *config=0);
	~KMIChannelWindow();
  /** No descriptions */
  const QString & getChannelName();
  /** No descriptions */
  bool isServer();
  /** No descriptions */
  QListBoxItem * findNickInChannel(const QString &);
  
public slots: // Public slots
  /** No descriptions */
  void output(const QString &);
  /** No descriptions */
  void slotAddUserToList(const QString &);
  /** No descriptions */
  void removeOp(const QString &);
  /** No descriptions */
  void addOp(const QString &);
  /** No descriptions */
  void removeVoice(const QString &user);
  /** No descriptions */
  void addVoice(const QString &user);
  /** No descriptions */
  void toggleNoMessagesFromOutside(bool);
  /** No descriptions */
  void toggleModerate(bool);
  /** No descriptions */
  void changeNickName(const QString &);
  /** No descriptions */
  void changeChannelNick(const QString &,const QString &);
  /** No descriptions */
  void removeUser(const QString &);
  /** No descriptions */
  void setTopicProtection(bool);
  /** No descriptions */
  void setAnonymous(bool);
  /** No descriptions */
  void toggleInviteOnly(bool);
  /** No descriptions */
  void toggleQuite(bool);
  /** No descriptions */
  void togglePrivate(bool);
  /** No descriptions */
  void toggleServerReOp(bool);
  /** No descriptions */
  void toggleSecret(bool);
  /** No descriptions */
  void toggleChannelLimit(bool,const QString &);
  /** No descriptions */
  void toggleChannelKey(bool,const QString &);
  /** No descriptions */
  void setTopic(const QString &);
  /** No descriptions */
  virtual void slotRightButtonPressed(QListBoxItem *,const QPoint &);
  /** No descriptions */
  bool isPrivateMsgWin();
  
#if QT_VERSION <= 304  
  /** No descriptions */
  void showEvent(QShowEvent *);
#endif
signals: // Signals
  /** No descriptions */
  void sendInput(const QString &,QWidget *);
protected slots: // Protected slots
  /** No descriptions */
  virtual void slotInputReturnPressed();
  /** No descriptions */
  virtual void enterEvent ( QEvent * );
  /** No descriptions */
  virtual void leaveEvent ( QEvent * );
  /** No descriptions */
  virtual void keyPressEvent(QKeyEvent *);
  /** No descriptions */

private: // Private attributes
  /**  */
  bool isServerWindow ;
  /**  */
  QString channelName;
  /**  */
  uint operators;
  /**  */
  uint voices;
  /**  */
  uint users;
  /**  */
  
  QPixmap picOper;

  /**  */
  
  QPixmap picVoice;
  
  /** */
  KMIConfig *cfg;

private: // Private methods
  /** No descriptions */
  void deactivateChannelSpecials();
  /**  */
  
  QPixmap picNoStatus;
  /**  */
  int largestNickInPixel;
  /**  */
  bool isPrivateMessageWindow;

private: // Private methods
  /** No descriptions */
  void activateChannelSpecials();
	void executeMultiCommands(const QString & commands, const QString & nickName, const QString & channelName);
protected slots: // Protected slots
  /** No descriptions */
  void changeNumberLabels();
  /** No descriptions */
  virtual void slotModeBtnL();
  /** No descriptions */
  virtual void slotModeBtnK();
  /** No descriptions */
  virtual void slotModeBtnQ();
  /** No descriptions */
  virtual void slotModeBtnR();
  /** No descriptions */
  virtual void slotModeBtnM();
  /** No descriptions */
  virtual void slotModeBtnP();
  /** No descriptions */
  virtual void slotModeBtnI();
  /** No descriptions */
  virtual void slotModeBtnS();
  /** No descriptions */
  virtual void slotModeBtnN();
  /** No descriptions */
  virtual void slotModeBtnA();
  /** No descriptions */
  virtual void slotModeBtnT();
private slots: // Private slots
  /** No descriptions */
  void viewActivated(QextMdiChildView *);

    private: bool parted;

    public: bool isParted();

    public: void setParted(bool);
};

#endif
