/***************************************************************************
                          kmiconfigdialog.cpp  -  description
                             -------------------
    begin                : Son Jun 23 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kmiconfigdialog.h"

KMIConfigDialog::KMIConfigDialog(QWidget *parent, const char *name ) : configDialog(parent,name,true) {
}
KMIConfigDialog::~KMIConfigDialog(){
}
/** No descriptions */
void KMIConfigDialog::setConfigParams(const s_Globals &glb){
  entryNick1->setText(glb.mainNickname);
  entryNick2->setText(glb.altNickname);
  entryRealname->setText(glb.realName);
  entryUsername->setText(glb.userName);
  checkUserInvisible->setChecked(glb.isInvisible);
  checkUserReceiveWallOps->setChecked(glb.receiveWallOps);
  checkServerList->setChecked(glb.noServerListAtStartUp);
  if (glb.showTime!=0){
    checkShowTime->setEnabled(true);
    checkShowTime->setChecked(true);
    comboShowTime->setCurrentItem(glb.showTime-1);
  }
  if (glb.highlightPhrase.isEmpty()) {
    checkHighlightPhrase->setChecked(false);
    entryHighlightPhrase->setText("");
  } else {
    checkHighlightPhrase->setChecked(true);
    entryHighlightPhrase->setText(glb.highlightPhrase);
  }
}
/** No descriptions */
void KMIConfigDialog::getConfigParams(s_Globals *glb){
  glb->mainNickname=entryNick1->text();
  glb->altNickname=entryNick2->text();
  glb->realName=entryRealname->text();
  glb->userName=entryUsername->text();
  glb->isInvisible=checkUserInvisible->isChecked();
  glb->receiveWallOps=checkUserReceiveWallOps->isChecked();
  glb->noServerListAtStartUp=checkServerList->isChecked();
  if (checkShowTime->isChecked()) {
    glb->showTime=comboShowTime->currentItem()+1;
  } else {
    glb->showTime=0;
  }
  if (checkHighlightPhrase->isChecked()) {
    glb->highlightPhrase=entryHighlightPhrase->text();
  } else {
    glb->highlightPhrase="";
  }
  
}
/** No descriptions */
void KMIConfigDialog::setServerList(serverList *list){
  QListViewItem *temp,*temp2;
  serverItem *temp1;
  sList=list;
  for (temp1=list->first();temp1;temp1=list->next()) {
    temp=listServer->findItem(temp1->group,0);
    if (temp!=0) {
      temp2=new QListViewItem(temp,temp1->name,temp1->serverName,QString("%1").arg(temp1->portNo));
      temp2->setPixmap(0,QPixmap(SmallIcon("server")));
    } else {
      temp=new QListViewItem(listServer,temp1->group);
      temp->setPixmap(0,QPixmap(SmallIcon("folder")));
      temp2=new QListViewItem(temp,temp1->name,temp1->serverName,QString("%1").arg(temp1->portNo));
      temp2->setPixmap(0,QPixmap(SmallIcon("server")));
    }
  }
}
///////////////////////// Message Text
/** No descriptions */
void KMIConfigDialog::setMessageTextList(textList *list){
  mList=list;
  for (s_msgText *temp=list->first();temp;temp=list->next()) {
    lviewMessageText->insertItem(new QListViewItem(lviewMessageText,temp->msgType,temp->msgText));
  }
}
/** No descriptions */
textList * KMIConfigDialog::getMessageTextList(){
  return mList;
}

/** No descriptions */
void KMIConfigDialog::updateMessageTextList(){
  QListViewItemIterator it(lviewMessageText);
  mList->setAutoDelete(true);
  mList->clear();
  while (it.current()!=0) {
    QListViewItem *temp=it.current();
    s_msgText *item=new s_msgText;
    item->msgType=temp->text(0);
    item->msgText=temp->text(1);
    mList->append(item);
    ++it;
  }
}

/** No descriptions */
void KMIConfigDialog::slotMsgDblClicked(QListViewItem *item){
  if (item!=0) {
    KMIChangeMsgText *dlg=new KMIChangeMsgText(this,"changeMessageText");
    dlg->setMessageType(item->text(0));
    dlg->setMessageText(item->text(1));
    if (dlg->exec()) {
      item->setText(1,dlg->getMsgText());
    }
    delete dlg;
  }
}

///////////////// MessageText Ends

/** No descriptions */
void KMIConfigDialog::slotRightBtnClicked(QListViewItem *item,const QPoint &p,int){
  // Show PopupMenu
  KPopupMenu *popup=new KPopupMenu(this,"serverList_popup");
  popup->insertItem(SmallIconSet("folder"),i18n("&Add Group"),100);
  popup->insertItem(SmallIconSet("folder"),i18n("Ed&it Group"),101);
  popup->insertItem(SmallIconSet("folder"),i18n("&Delete Group"),102);
  popup->insertSeparator();
  popup->insertItem(SmallIconSet("server"),i18n("Add &Server"),103);
  popup->insertItem(SmallIconSet("server"),i18n("Edit Se&rver"),104);
  popup->insertItem(SmallIconSet("server"),i18n("Delete S&erver"),105);
  if (item!=0) {
    qWarning("hello");
    if (item->parent()==0) {
      popup->setItemEnabled(100,true);
      popup->setItemEnabled(101,true);
      popup->setItemEnabled(102,true);
      popup->setItemEnabled(103,true);
      popup->setItemEnabled(104,false);
      popup->setItemEnabled(105,false);

    } else {
      popup->setItemEnabled(100,true);
      popup->setItemEnabled(101,false);
      popup->setItemEnabled(102,false);
      popup->setItemEnabled(103,false);
      popup->setItemEnabled(104,true);
      popup->setItemEnabled(105,true);
    }
  } else {
    popup->setItemEnabled(100,true);
    popup->setItemEnabled(101,false);
    popup->setItemEnabled(102,false);
    popup->setItemEnabled(103,false);
    popup->setItemEnabled(104,false);
    popup->setItemEnabled(105,false);
  }
  uint i=popup->exec(p);
  switch(i) {
    case 100: { // Add Group
      KMIAddGroup *dlg=new KMIAddGroup(this,"addGroupDlg");
      if (dlg->exec()) {
        QListViewItem *temp=new QListViewItem(listServer,dlg->getGroupName());
        temp->setPixmap(0,SmallIcon("folder"));
      }
      delete dlg;
      break;
    }
    case 101: { // Edit Group
      KMIAddGroup *dlg=new KMIAddGroup(this,"addGroupDlg");
      dlg->setGroupName(item->text(0));
      if (dlg->exec()) {
        item->setText(0,dlg->getGroupName());
      }
      delete dlg;    
      break;
    }
    case 102: { // Delete group
      delete item;
      break;
    }
    case 103: { // Add Server
      KMIAddServer *dlg=new KMIAddServer(this,"addServerDlg");
      if (dlg->exec()) {
      	if (!dlg->getServerName().isEmpty()) {
        	QListViewItem *temp=new QListViewItem(item,dlg->getDescription(),dlg->getServerName(),QString("%1").arg(dlg->getPort()));
        	temp->setPixmap(0,SmallIcon("server"));
	}
      }
      delete dlg;
      break;
    }
    case 104: { // Edit Server
      KMIAddServer *dlg=new KMIAddServer(this,"addServerDlg");
      dlg->setDescription(item->text(0));
      dlg->setServerName(item->text(1));
      dlg->setPort(item->text(2).toInt());
      if (dlg->exec()) {
        item->setText(0,dlg->getDescription());
        item->setText(1,dlg->getServerName());
        item->setText(2,QString("%1").arg(dlg->getPort()));
      }
      delete dlg;
      break;
    }
    case 105: { // Delete Server
      if (item->parent()!=0) {
        delete item;
      }
      break;
    }
  }
  delete popup;
}
/** No descriptions */
void KMIConfigDialog::updateServerList(){
  QListViewItemIterator it(listServer);
  sList->setAutoDelete(true);
  sList->clear();
  while (it.current()!=0) {
    if (it.current()->parent()!=0) {
      serverItem *item=new serverItem;
      item->group=it.current()->parent()->text(0);
      item->name=it.current()->text(0);
      item->serverName=it.current()->text(1);
      item->portNo=it.current()->text(2).toUInt();
      sList->append(item);
    }
    ++it;
  }
}
/** No descriptions */
serverList *KMIConfigDialog::getServerList(){
  return sList;
}

/////////////////////////// ColorList
/** No descriptions */
colorList * KMIConfigDialog::getColorList(){
  return cList;
}

/** No descriptions */
void KMIConfigDialog::setColors(colorList *list){
  for (s_msgColors *temp=list->first();temp;temp=list->next()) {
    lviewMsgColors->insertItem(new KMIColorListViewItem(lviewMsgColors,temp->msgType,temp->msgColor));
  }
  cList=list;
}

/** No descriptions */
void KMIConfigDialog::updateColorList(){
  QListViewItemIterator it(lviewMsgColors);
  cList->setAutoDelete(true);
  cList->clear();
  while (it.current()!=0) {
    KMIColorListViewItem *temp=(KMIColorListViewItem *)it.current();
    s_msgColors *item=new s_msgColors;
    item->msgType=temp->text(0);
    item->msgColor=temp->getColor();
    cList->append(item);
    ++it;
  }
}

/** No descriptions */
void KMIConfigDialog::slotColorDblClick(QListViewItem *item){
  KMIColorListViewItem *temp=(KMIColorListViewItem *)item;
  QColor newColor=temp->getColor();
  int result=KColorDialog::getColor(newColor,temp->getColor(),this);
  if (result==KColorDialog::Accepted) {
    temp->setColor(newColor);
  }
}/** No descriptions */
bool KMIConfigDialog::getInvisibleUser(){
  return checkUserInvisible->isChecked();
}
/** No descriptions */
void KMIConfigDialog::setUserInvisible(bool check){
  checkUserInvisible->setChecked(check);
}
/** No descriptions */
bool KMIConfigDialog::getWallOps(){
  return checkUserReceiveWallOps->isChecked();
}
/** No descriptions */
void KMIConfigDialog::setWallOps(bool check){
  checkUserReceiveWallOps->setChecked(check);
}
/** No descriptions */
bool KMIConfigDialog::isNoServerListAtStartUp(){
  return checkServerList->isChecked();
}
/** No descriptions */
void KMIConfigDialog::setNoServerListAtStartUp(bool checked){
  checkServerList->setChecked(checked);
}
/** No descriptions */
void KMIConfigDialog::slotShowTime(bool checked){
  if (checked)  {
    comboShowTime->setEnabled(true);
  } else {
    comboShowTime->setEnabled(false);
  }  
}
/** No descriptions */
void KMIConfigDialog::slotHighlightPhrase(bool checked){
   if (checked) {
     entryHighlightPhrase->setEnabled(true);
   } else {
     entryHighlightPhrase->setEnabled(false);
   }
}
                                                                        
void KMIConfigDialog::slotServerDblClk(QListViewItem * item)
{
	if (item!=0) {
		// Check if item is a serveritem
		if (item->parent()!=0) {
			KMIAddServer *dlg=new KMIAddServer(this,"addServerDlg");
			if (dlg->exec()) {
				QListViewItem *temp=new QListViewItem(item,dlg->getDescription(),dlg->getServerName(),QString("%1").arg(dlg->getPort()));
				temp->setPixmap(0,SmallIcon("server"));
			}
			delete dlg;
		}
	}
}
