/***************************************************************************
                          kmiconfigdialog.h  -  description
                             -------------------
    begin                : Son Jun 23 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMICONFIGDIALOG_H
#define KMICONFIGDIALOG_H

// QT includes
#include <qwidget.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qpixmap.h>
#include <qiconset.h>
#include <qcheckbox.h>
#include <qcombobox.h>

// KDE INcludes
#include <klocale.h>
#include <kpopupmenu.h>
#include <kiconloader.h>
#include <kcolordialog.h>

// Local includes
#include "../ircgui/configdialog.h"
#include "../ircgui/kmiaddgroup.h"
#include "../ircgui/kmiaddserver.h"
#include "../ircgui/kmichangemsgtext.h"
#include "../widgets/kmiwidgets/kmicolorlistviewitem.h"
#include "../logic/structures.h"

/**
  *@author Stephan Hermann
  */

class KMIConfigDialog : public configDialog  {
   Q_OBJECT
public: 
	KMIConfigDialog(QWidget *parent=0, const char *name=0);
	~KMIConfigDialog();
  /** No descriptions */
  void setConfigParams(const s_Globals &);
  /** No descriptions */
  void getConfigParams(s_Globals *glb);
  /** No descriptions */
  void setServerList(serverList *list);
  /** No descriptions */
  void updateServerList();
  /** No descriptions */
  serverList *getServerList();
  /** No descriptions */
  void setMessageTextList(textList *list);
  /** No descriptions */
  textList * getMessageTextList();
  /** No descriptions */
  void updateMessageTextList();
  /** No descriptions */  
  void updateColorList();
  void setColors(colorList *list);
  colorList * getColorList();
  /** No descriptions */
  void setWallOps(bool check);
  /** No descriptions */
  bool getWallOps();
  /** No descriptions */
  void setUserInvisible(bool check);
  /** No descriptions */
  bool getInvisibleUser();
  /** No descriptions */
  bool isNoServerListAtStartUp();
  /** No descriptions */
  void setNoServerListAtStartUp(bool checked);
protected slots: // Protected slots
  /** No descriptions */
  virtual void slotRightBtnClicked(QListViewItem *,const QPoint &,int);
  /** No descriptions */
  virtual void slotMsgDblClicked(QListViewItem *);
  /** No descriptions */
  virtual void slotColorDblClick(QListViewItem *);
private: // Private attributes
  /**  */
  serverList *sList;
  /**  */
  textList *mList;
  /**  */
  colorList * cList;

protected slots: // Protected slots
  /** No descriptions */
  virtual void slotShowTime(bool);
protected slots: // Protected slots
  /** No descriptions */
  virtual void slotHighlightPhrase(bool);
protected slots:
	virtual void slotServerDblClk(QListViewItem * );
};

#endif

