/***************************************************************************
                          kmipopupedit.cpp  -  description
                             -------------------
    begin                : Wed Nov 6 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kmipopupedit.h"

KMIPopupEdit::KMIPopupEdit(QWidget *parent, const char *name,l_aliasCmdList *cfg ) : popupEditDlg(parent,name,true) {
	comboPopupMenu->insertItem(i18n("Channel Inputline"));
  comboPopupMenu->insertItem(i18n("User Popup"));
  ll=new l_aliasCmdList();
	comboPopupMenu->setCurrentItem(0);
  for (s_aliasList *tt=cfg->first();tt;tt=cfg->next()) {
  	if (tt->ofType=comboPopupMenu->currentItem()) {
    	lviewPopupCreator->insertItem(new QListViewItem(lviewPopupCreator,tt->aliasName,tt->aliasCommands));
    }
    s_aliasList *item=new s_aliasList;
    item->aliasName=tt->aliasName;
    item->aliasCommands=tt->aliasCommands;
    item->ofType=tt->ofType;
    ll->append(item);
  }
  
}
KMIPopupEdit::~KMIPopupEdit(){
	delete ll;
}
void KMIPopupEdit::slotLviewPopup(QListViewItem *item,const QPoint &p,int) {
  QPopupMenu *popup=new QPopupMenu(this);
  popup->insertItem(i18n("&Add Alias"),100);
  popup->insertItem(i18n("&Edit Alias"),101);
  popup->insertItem(i18n("&Delete Alias"),102);
  int id=popup->exec(p);
  switch(id) {
    case 100: {
      KMIAliasDlg *dlg=new KMIAliasDlg(this,"aliasDlg");      
      if (dlg->exec()) {
        // config->getAliasList().clear();
        s_aliasList *alias=new s_aliasList;
        alias->aliasName=dlg->getAliasName();
        alias->aliasCommands=dlg->getAliasCommands();
        alias->ofType=comboPopupMenu->currentItem();
        ll->append(alias);
        lviewPopupCreator->insertItem(new QListViewItem(lviewPopupCreator,dlg->getAliasName()));
      }
      delete dlg;
      break;
    }
    case 101:{
      KMIAliasDlg *dlg=new KMIAliasDlg(this,"aliasDlg");
      dlg->setAliasName(item->text(0));
      dlg->setAliasCommands(findAlias(item->text(0)));
      s_aliasList *alias=findAliasPtr(item->text(0));
      if (dlg->exec()) {
      	alias->aliasName=dlg->getAliasName();
				alias->aliasCommands=dlg->getAliasCommands();
				alias->ofType=comboPopupMenu->currentItem();
				item->setText(0,dlg->getAliasName());
      }
      delete dlg;
      break;
    }
    case 102: {
    	QString aliasName;
	aliasName=item->text(0);
	delete findAliasPtr(aliasName);
	delete item;
	break;
    }
  }
  delete popup;
}

void KMIPopupEdit::slotLviewPopup(QListViewItem * item)
{
			// Edit Item
      KMIAliasDlg *dlg=new KMIAliasDlg(this,"aliasDlg");
      dlg->setAliasName(item->text(0));
      dlg->setAliasCommands(findAlias(item->text(0)));
      s_aliasList *alias=findAliasPtr(item->text(0));
      if (dlg->exec()) {
      	alias->aliasName=dlg->getAliasName();
				alias->aliasCommands=dlg->getAliasCommands();
				alias->ofType=comboPopupMenu->currentItem();
				item->setText(0,dlg->getAliasName());
      }
      delete dlg;
	
}

s_aliasList *KMIPopupEdit::findAliasPtr(const QString &alias)
{
	for (s_aliasList *i=ll->first();i;i=ll->next()) {
		if (i->aliasName==alias) {
			return i;
		}
	}
	return NULL;

}

l_aliasCmdList *KMIPopupEdit::getAliasList()
{
	return ll;
}

QString KMIPopupEdit::findAlias(const QString &alias)
{
 for (s_aliasList *i=ll->first();i;i=ll->next()) {
    if (i->aliasName==alias) {
      return i->aliasCommands;
    }
  }
  return QString("");
}

void KMIPopupEdit::slotComboPopupActivated(int item)
{
	lviewPopupCreator->clear();
  for (s_aliasList *tt=ll->first();tt;tt=ll->next()) {
  	if (tt->ofType=comboPopupMenu->currentItem()) {
    	lviewPopupCreator->insertItem(new QListViewItem(lviewPopupCreator,tt->aliasName,tt->aliasCommands));
		}
  }
}
