
#include "kmirawircwindow.h"


KMIRawIRCWindow::KMIRawIRCWindow(QWidget *parent, const char *name)
  : mdiRawIRCWin(parent, name)
{
  setCaption("Raw IRC Message Window");
  setTabCaption("Raw IRC Message Window");
  setMDICaption("Raw IRC Message Window");
  logFile=0;
}


KMIRawIRCWindow::~KMIRawIRCWindow()
{
}

void KMIRawIRCWindow::output(const QString & str)
{
	tbRawIRC->append(str);
  if (logFile!=0) {
		*stream << str << "\n";
  }
}


void KMIRawIRCWindow::slotEnableWidgets(bool toggle)
{
	if (toggle==true) {
		QString filen=editFileName->text();
		if (!filen.isEmpty()) {
			// Open File
			logFile=new QFile (editFileName->text());
			logFile->open(IO_WriteOnly | IO_Append);
			stream=new QTextStream(logFile);
		} else {
			cbLogCheck->setChecked(false);
		}
	} else {
		// Close File
		if (logFile!=0) {
    	logFile->close();
			delete logFile;
		}
	}	
}

void KMIRawIRCWindow::slotSelectFile()
{
	QString fileName=KFileDialog::getSaveFileName(QString::null,"*.log|"+i18n("Logfiles")+" *|"+i18n("All Files"),this,"Save Log to ...");
	editFileName->setText(fileName);
}
