/***************************************************************************
                          kmyirc.h  -  description
                             -------------------
    begin                : Son Jun 16 13:43:09 CEST 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMYIRC_H
#define KMYIRC_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// QT Includes
#include <qwidget.h>
#include <qdict.h>
#include <qcolor.h>

// KDE Includes
#include <kapp.h>
#include <kmainwindow.h>
#include <klocale.h>
#include <kaction.h>
#include <kstdaction.h>
#include <kmenubar.h>
#include <khelpmenu.h>
#include <kdockwidget.h>
#include <kstatusbar.h>
#include <kshortcut.h>


#include <kdebug.h>

// Local Includes
#include "network/kminetworkclient.h"
#include "ircgui/kmichannelwindow.h"
#include "logic/kmilogic.h"
#include "logic/structures.h"
#include "logic/kmiconfig.h"
#include "ircgui/kmiconfigdialog.h"
#include "ircgui/kmiconnectdlg.h"
#include "ircgui/kmichannelevents.h"
#include "ircgui/kmichannellist.h"
#include "ircgui/kmictcpreplies.h"
#include "ircgui/kmipopupedit.h"
#include "ircgui/kmirawircwindow.h"

// CTCP Handler
#include "logic/returncodes.h"
// Input Command Task Handler
#include "logic/kmiinputcommand.h"
#include "logic/kmicommandnotice.h"
#include "logic/kmicommandmsg.h"
#include "logic/kmicommandjoin.h"
#include "logic/kmicommandnick.h"
#include "logic/kmicommandmode.h"
#include "logic/kmicommandwhois.h"
#include "logic/kmicommandwho.h"
#include "logic/kmicommandaway.h"
#include "logic/kmicommandusers.h"
#include "logic/kmicommandkick.h"
#include "logic/kmicommandpart.h"
#include "logic/kmicommandnames.h"
#include "logic/kmicommandinvite.h"
#include "logic/kmicommandquit.h"
#include "logic/kmicommandtopic.h"
#include "logic/kmicommandluser.h"
#include "logic/kmicommandversion.h"
#include "logic/kmicommandlist.h"
#include "logic/kmicommandstats.h"
#include "logic/kmicommandlinks.h"
#include "logic/kmicommandtime.h"
#include "logic/kmicommandtrace.h"
#include "logic/kmicommandadmin.h"
#include "logic/kmicommandinfo.h"
#include "logic/kmicommandservlist.h"
#include "logic/kmicommandwhowas.h"
#include "logic/kmicommandctcp.h"
#include "logic/kmicommandleave.h"



// CTCP Handler
#include "logic/kmictcphandler.h"
#include "logic/kmictcpactionhandler.h"
#include "logic/kmictcpversionhandler.h"
#include "logic/kmictcpsourcehandler.h"
#include "logic/kmictcpcommonhandler.h"
#include "logic/kmioutputrender.h"



// QExtMDI WIndow
#include "widgets/qextmdi/include/qextmdimainfrm.h"




/** KMyIRC is the base class of the project */
class KMyIRC : public QextMdiMainFrm
{
  Q_OBJECT 
  public:
    /** construtor */
    KMyIRC(QWidget* parent=0, const char *name=0);
    /** destructor */
    ~KMyIRC();
private: // Private attributes
  /**  */
  KMINetworkClient * networkClient;
  /**  */
  KMILogic * ircLogic;
  /**  */
  KActionCollection * actionCollection;
  /**  */
  // KMenuBar * menuBar;
  /**  */
  QDict<KMIChannelWindow> channels;
  /**  */
  KMIConfig * config;
  /**  */
  QString serverHost;
  /**  */
  bool isConnected;
  /**  */
  KMICTCPHandler * ctcpHandlerRoot;
  /**  */
  int nickTry;
  /**  */
  serverItem * connectedServer;
  /**  */
  KMIOutputRender * render;
  /**  */
  KMIInputCommand * commandHandlerRoot;
  /**  */
  KMIChannelList * chanList;
	KPopupMenu * channel;
	KPopupMenu * file;
	KPopupMenu * configMenu;
	KPopupMenu * misc;
protected slots: // Protected slots
  /** No descriptions */
  virtual void slotConnectionEstablished();
public slots: // Public slots
  /** No descriptions */
  void slotDoLogin();
  /** No descriptions */
  void slotQuitApplication();
  /** No descriptions */
  void connectionEstablished(const QString &);
  /** No descriptions */
  void sendOutput(const QString &,const QString &);
  /** No descriptions */
  void sendOutput(const QString &);
  /** No descriptions */
  void joinChannel(const QString &);
  /** No descriptions */
  void addUserToList(const QString &,const QString &);
  /** No descriptions */
  void sendOutputToChannel(const QString &,const QString &);
  /** No descriptions */
  void sendRemoveOperatorStatus(const QString &,const QString &);
  /** No descriptions */
  void sendSetOperatorStatus(const QString &,const QString &);
  /** No descriptions */
  void sendRemoveVoice(const QString &,const QString &);
  /** No descriptions */
  void sendSetVoice(const QString &,const QString &);
  /** No descriptions */
  void sendSetNoMessagesFromOutside(const QString &,bool);
  /** No descriptions */
  void sendSetModerated(const QString &,bool);
  /** No descriptions */
  void setNickName(const QString &);
  /** No descriptions */
  void changeNick(const QString &,const QString &);
  /** No descriptions */
  void closeChannelWindow(const QString &);
  /** No descriptions */
  void removeUserFromChannel(const QString &,const QString &);
  /** No descriptions */
  void sendSetAnonymous(const QString &,bool);
  /** No descriptions */
  void sendSetTopicProtection(const QString &,bool);
  /** No descriptions */
  void sendPrivateMessageFrom(const QString &,const QString &,const QString &);
  /** No descriptions */
  void sendSetInviteOnly(const QString &,bool);
  /** No descriptions */
  void sendSetQuite(const QString &,bool);
  /** No descriptions */
  void sendSetServerReOp(const QString &,bool);
  /** No descriptions */
  void sendSetSecret(const QString &,bool);
  /** No descriptions */
  void sendSetPrivate(const QString &,bool);
  /** No descriptions */
  void sendChannelLimit(const QString &,bool,const QString &);
  /** No descriptions */
  void sendChannelKey(const QString &,bool,const QString &);
  /** No descriptions */
  void sendNickAlreadyInUse();
  /** No descriptions */
  void sendSetTopic(const QString &,const QString &);
  /** No descriptions */
  void setQuitMessage(const QString &,const QString &);
  /** No descriptions */
  void slotConfigCTCPReturns();
  /** No descriptions */
  void sendMotdToView(const QString &,const QString &);
  /** No descriptions */
  void sendPrivmsgToChannel(const QString &,const QString &,const QString &);
  /** No descriptions */
  void sendAction(const QString &,const QString &,const QString &);
  /** No descriptions */
  void sendNotice(const QString &,const QString &,const QString &);
  /** No descriptions */
  void sendNickChange(const QString &,const QString &,const QString &);
  /** No descriptions */
  void sendUserModeChange(const QString &,const QString &);
  /** No descriptions */
  void removeUserFromChannels(const QString &,const QString &);
  /** No descriptions */
  void sendChannelModeChange(const QString &,const QString &);
  /** No descriptions */
  void sendErrorMessage(const QString &,const QString &, const QString &);
  /** No descriptions */
  virtual void closeWindow (QextMdiChildView *pWnd, bool layoutTaskBar = TRUE)  ;
  /** No descriptions */
  KMIConfig * getCfg();
  /** No descriptions */
  void resizeEvent ( QResizeEvent *e);
  /** No descriptions */
  void sendNameReply(const QString &);
  /** No descriptions */
  void sendMsgToChannel(const QString &,const QString &,const QString &);
  /** No descriptions */
  void sendWhois(const QString &,const QString &);
  /** No descriptions */
  void sendAway(const QString &,const QString &);
  /** No descriptions */
  void sendWho(const QString &,const QString &);
  /** No descriptions */
  void sendUsers(const QString &,const QString &);
  /** No descriptions */
  void sendKickMessage(const QString &,const QString &);
  /** No descriptions */
  void sendInviteMessage(const QString &,const QString &);
  /** No descriptions */
  void sendLUserMsg(const QString &,const QString &);
  /** No descriptions */
  void sendVersionMsg(const QString &,const QString &);
  /** No descriptions */
  void slotListChannels();
  /** No descriptions */
  void sendListMsg(const QString &,const QString &,const QString &);
  /** No descriptions */
  void sendStatsLinkInfo(const QString &,const QString &);
  /** No descriptions */
  void sendStatsCommand(const QString &,const QString &);
  /** No descriptions */
  void sendStatsUptime(const QString &,const QString &);
  /** No descriptions */
  void sendStatsOLine(const QString &,const QString &);
  /** No descriptions */
  void sendEndOfStats(const QString &,const QString &);
  /** No descriptions */
  void sendEndOfLinksMsg(const QString &,const QString &);
  /** No descriptions */
  void sendLinksMsg(const QString &,const QString &);
  /** No descriptions */
  void sendTimeMsg(const QString &,const QString &);
  /** No descriptions */
  void sendTraceMsg(const QString &,const QString &);
  /** No descriptions */
  void sendAdminMsg(const QString &,const QString &);
  /** No descriptions */
  void sendInfoMsg(const QString &,const QString &);
  /** No descriptions */
  void sendServListMsg(const QString &,const QString &);
private: // Private methods
  /** No descriptions */
  void initWindow();
  /** No descriptions */
  void initMenuBar();
  /** No descriptions */
  void initCommandHandler();
  /** No descriptions */
  void initCTCPHandler();
  /** No descriptions */
  void initStatusBar();
  /** No descriptions */
  void changeTabButton(KMIChannelWindow *);
signals: // Signals
  /** No descriptions */
  void sendInput(const QString &,QWidget *);
protected slots: // Protected slots
  /** No descriptions */
  virtual void slotConfigServer();
protected slots: // Protected slots
  /** No descriptions */
  virtual void activateView(QextMdiChildView *pWnd);
protected:
  /** No descriptions */
  virtual void closeEvent(QCloseEvent *e);

protected slots: // Protected slots

  void slotConfigPopupEdit();
	void slotRawIRCWindow();
};

#endif
