/***************************************************************************
                          kmiconfig.h  -  description
                             -------------------
    begin                : Son Jun 23 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMICONFIG_H
#define KMICONFIG_H

// QT Includes
#include <qobject.h>
#include <qmap.h>
#include <qptrlist.h>

// KDE Includes
#include <kglobal.h>
#include <ksimpleconfig.h>

// Local includes
#include "../logic/structures.h"


/**
  *@author Stephan Hermann
  */

class KMIConfig : public QObject  {
  Q_OBJECT
public: 
	KMIConfig(QObject *parent=0,const char *name=0);
	~KMIConfig();
  /** No descriptions */
  void setGlobals(s_Globals *);
  /** No descriptions */
  s_Globals * getGlobals();
  /** No descriptions */
  void setServerList(serverList *list);
  /** No descriptions */
  serverList *getServerList();
  /** No descriptions */
  void writeGlobals();  
  /** No descriptions */
  serverItem * getServerItem(const QString &server);
  /** No descriptions */
  colorList * getColorList();
  /** No descriptions */
  void setColorList(colorList *);
  /** No descriptions */
  textList * getMessageTextList();
  /** No descriptions */
  void setMessageTextList(textList *list);
  /** No descriptions */
  void setMyNick(const QString &nick);
  /** No descriptions */
  const QString & getMyNick();
  /** No descriptions */
  QString findMessageText(const QString &msgType);
  /** No descriptions */
  QString findColor(const QString &msgType);
  /** No descriptions */
  textList * getCtcpReplies();
  /** No descriptions */
  void setCtcpReplies(textList *list);
  /** No descriptions */
  l_aliasCmdList* getAliasList();
  /** No descriptions */
  QString findAlias(const QString &);
  s_aliasList* findAliasPtr(const QString & name);
	void setAliasList(l_aliasCmdList *list = 0);
private: // Private attributes
  /**  */
  // KSimpleConfig * cfg;
  KConfig * cfg;
  /**  */
  s_Globals * globals;
  /**  */
  serverList *listServer;
  /**  */
  colorList * listColors;
  /**  */
  textList * listMessageText;
  /**  */
  QString myNick;
  /**  */
  textList * listCtcpReplies;
  /**  */
  l_aliasCmdList *aliasList;
private: // Private methods
  /** No descriptions */
  void readGlobals();
  /** No descriptions */
  void deleteGroups();
};

#endif
