/***************************************************************************
                          kmictcphandler.cpp  -  description
                             -------------------
    begin                : Sam Jun 29 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kmictcphandler.h"
#include <qobjectlist.h>

KMICTCPHandler::KMICTCPHandler(QObject *parent,const char *name,KMIConfig *cfg):QObject(parent,name){
  ctcpParser=new KMICTCPParser(this,"ctcpParser");
  isRoot=true;
  v_parent=0;
  v_config=cfg;
  from="";
  channel="";
}

KMICTCPHandler::KMICTCPHandler(KMICTCPHandler *handler,const char *name):QObject(handler,name) {
  isRoot=false;
  handledAction=QString(name).lower();
  v_parent=handler;
  ctcpParser=v_parent->getParser();
  v_config=v_parent->getConfig();
  from=v_parent->getFrom();
  channel=v_parent->getChannel();
  
}

KMICTCPHandler::~KMICTCPHandler(){
  // delete ctcpParser;
}
/** No descriptions */
QString KMICTCPHandler::ctcpOutput(const QString &_from,const QString &_channel,const QString &message){
  QString temp=message;
  ctcpMessage *cMsg=ctcpParser->parseCtcp(temp);
  from=_from;
  channel=_channel;
  if (cMsg->strCommand=="NONE") {
    return "";
  } else {
    // Run through child list
    const QObjectList *p = children();
    if (!p) {
      return QString("!!!!!!!!!!! NO CTCP HANDLERS INITIALIZED !!!!!!!!!!!!!");
    }
    QObjectListIt it(*p);
    KMICTCPHandler *j;
    for (;it.current();++it) {
      j=static_cast<KMICTCPHandler*>(it.current());
      if (!j->isRoot) {
        QString out=j->getOutput(cMsg);
        if (!out.isEmpty()) {
          return out;
        }
      }
    }
    return "UNKNOWN";
  }
}

/** No descriptions */
KMICTCPParser * KMICTCPHandler::getParser(){
  return ctcpParser;
}
/** No descriptions */
KMICTCPHandler * KMICTCPHandler::getParent(){
  return v_parent;
}
/** No descriptions */
QString KMICTCPHandler::getOutput(ctcpMessage *ctcp){
  return "";
}
/** No descriptions */
const QString & KMICTCPHandler::getHandledAction(){
  return handledAction;
}
/** No descriptions */
KMIConfig * KMICTCPHandler::getConfig(){
  return v_config;
}
/** No descriptions */
const QString & KMICTCPHandler::getFrom(){
  return from;
}
/** No descriptions */
QString & KMICTCPHandler::getChannel(){
  return channel;
}
