/***************************************************************************
                          kmictcpparser.cpp  -  description
                             -------------------
    begin                : Fre Jun 28 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kmictcpparser.h"

KMICTCPParser::KMICTCPParser(QObject *parent,const char *name):QObject(parent,name){
}
KMICTCPParser::~KMICTCPParser(){
}
/** No descriptions */
ctcpMessage * KMICTCPParser::parseCtcp(const QString &ctcpString){
  ctcpMessage *msg=new ctcpMessage;
  QString temp=ctcpString;
  QString temp1;
  if (temp.contains('\001')) {
    temp.replace(temp.find('\001'),1,"");
    temp.replace(temp.find('\001'),1,"");
    
    msg->strCommand=temp.left(temp.find(' ')).lower();
    temp.replace(0,temp.find(' ')+1,"");
    temp1=temp.left(temp.find('\001'));    
    msg->message=ctcpDequote(temp1);
  } else {
    msg->strCommand="NONE";
    msg->message="";
  }
  return msg;
}
/** No descriptions */
QString KMICTCPParser::ctcpDequote(const QString &message){
  QString temp=message;
  if (temp.contains('\001')) {
    temp.replace(temp.find('\001'),1,"");
    temp.replace(temp.find('\001'),1,"");
  }
  if (temp.contains('\020')) {
    if (temp.at(temp.find('\020')+1)=='n') {
      temp.replace(temp.find('\020'),2,"\n");
    } else if (temp.at(temp.find('\020')+1)=='0') {
      temp.replace(temp.find('\020'),2,"\0");
    } else if (temp.at(temp.find('\020')+1)=='r') {
      temp.replace(temp.find('\x020'),2,"\r");
    } else if (temp.at(temp.find('\020')+1)=='\020') {
      temp.replace(temp.find('\020'),2,"\\");
    }
  }
  return temp;
}
/** No descriptions */
QString KMICTCPParser::ctcpEnquote(const QString &message){
  QString temp=message;
  while (temp.contains('\\')) {
    temp.replace(temp.find('\\'),1,"\020");
  }
  return temp;
}
/** No descriptions */
QString KMICTCPParser::getCTCPMessage(const QString &message){
  QString temp=message;
  temp=ctcpEnquote(temp);
  temp='\001'+temp+'\001';
  return temp;
}
