/***************************************************************************
                          kmiinputcommand.cpp  -  description
                             -------------------
    begin                : Fre Jul 5 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kmiinputcommand.h"
#include <qobjectlist.h>


KMIInputCommand::KMIInputCommand(QObject *parent,const char *name,KMIOutputRender *_renderOutput):QObject(parent,name){
  commandLine="";
  isRoot=true;
  v_parent=0;
  v_renderOutput=_renderOutput;
}

KMIInputCommand::KMIInputCommand(KMIInputCommand *handler,const char *name):QObject(handler,name){
  commandLine="";
  isRoot=false;
  v_parent=handler;
  handledCommand=name;
  v_renderOutput=handler->getOutputRender();
}

KMIInputCommand::~KMIInputCommand(){
}
/** No descriptions */
void KMIInputCommand::getCommandLine(const QString &channelName,const QString &myNick,const QString &command){
  commandLine=command;
  channel=channelName;
  v_myNick=myNick;
  parseCommandLine();
}
/** No descriptions */
void KMIInputCommand::parseCommandLine(){
  QString line=commandLine;
  if (line[0]=='/') {
    line.remove(0,1);
    QString params;
    QString command;
    if (line.find(" ")!=-1){
      command=line.left(line.find(" "));
      line.remove(0,line.find(" ")+1);
      params=line;
    } else {
      command=line;
    }
    const QObjectList *p = children();
    QObjectListIt it(*p);
    KMIInputCommand *j;
    for (;it.current();++it) {
      j=static_cast<KMIInputCommand*>(it.current());
      if (!j->isRoot) {
        QString out=j->checkCommand(channel,v_myNick,command,params);
        if (!out.isEmpty()) {
          // sendCommand(out+"\n");
          break;
        }
      }
    }    
  }
}
/** No descriptions */
QString KMIInputCommand::checkCommand(const QString &,const QString &,const QString &,const QString &){
  return QString("");
}
/** No descriptions */
const QString & KMIInputCommand::getHandledCommand(){
  return handledCommand;
}
/** No descriptions */
KMIOutputRender * KMIInputCommand::getOutputRender(){
  return v_renderOutput;
}
/** No descriptions */
KMIInputCommand * KMIInputCommand::findCommandHandler(const QString &command){
  
  const QObjectList *p = children();
  QObjectListIt it(*p);
  KMIInputCommand *j;
  for (;it.current();++it) {
    j=static_cast<KMIInputCommand*>(it.current());
    if (!j->isRoot) {
      if (j->getHandledCommand().lower()==command.lower()) {
        return j;
      }
    }
  }
  return 0;
}
