/***************************************************************************
                          kmiinputcommand.h  -  description
                             -------------------
    begin                : Fre Jul 5 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMIINPUTCOMMAND_H
#define KMIINPUTCOMMAND_H

#include <qobject.h>
#include <qdict.h>
#include "../logic/kmioutputrender.h"

/**
  *@author Stephan Hermann
  */

class KMIInputCommand : public QObject  {
  Q_OBJECT
public:

  KMIInputCommand(QObject* parent=0,const char *name=0,KMIOutputRender *_renderOutput=0);
  KMIInputCommand(KMIInputCommand *handler,const char *name=0);
	~KMIInputCommand();
  /** No descriptions */
  KMIInputCommand * findCommandHandler(const QString &command);
private: // Private attributes
  /**  */
  QString commandLine;
  /**  */
  QString channel;
  /**  */
  bool isRoot;
  /**  */
  KMIInputCommand * v_parent;
  /**  */
  QString handledCommand;
  /**  */
  QString v_myNick;
  /**  */
  KMIOutputRender * v_renderOutput;
public slots: // Public slots
  /** No descriptions */
  void getCommandLine(const QString &,const QString &,const QString &);
private: // Private methods
  /** No descriptions */
  void parseCommandLine();
protected: // Protected methods
  /** No descriptions */
  virtual QString checkCommand(const QString &,const QString &,const QString &,const QString &);
  /** No descriptions */
  const QString & getHandledCommand();
  /** No descriptions */
  KMIOutputRender * getOutputRender();
signals: // Signals
  /** No descriptions */
  void sendCommand(const QString &);
signals: // Signals
  /** No descriptions */
  void sendMsgToChannel(const QString &,const QString &,const QString &);
};

#endif
