//
//
// C++ Implementation: cpp
//
// Description: 
//
//
// Author: Stephan Hermann| <sh@sourcecode.de>, (C) 2003
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "kmiircmessage.h"


KMIIrcMessage::KMIIrcMessage(QObject *parent,const char *name)
 : QObject(parent,name)
{
}

KMIIrcMessage::~KMIIrcMessage()
{
}


void KMIIrcMessage::parseMessage(const QString & inLine)
{

  // Portions (C) by the guys of konversation

  QString trailing="";
  QString newLine=inLine;
  // Remove white spaces at the end and beginning
  newLine=newLine.stripWhiteSpace();
  // Find end of middle parameter list
  int pos=newLine.find(" :");
  // Was there a trailing parameter?
  if(pos!=-1)
  {
    // Copy trailing parameter
    trailing=newLine.mid(pos+2);
    // Cut trailing parameter from string
    newLine=newLine.left(pos);
  }
  // Remove all unneccessary white spaces to make parsing easier
  QString incomingLine=newLine.simplifyWhiteSpace();

  QString prefix="";
  // Do we have a prefix?
  if(incomingLine[0]==':')
  {
    // Find end of prefix
    pos=incomingLine.find(' ');
    // Copy prefix
    prefix=incomingLine.mid(1,pos-1);
    // Remove prefix from line
    incomingLine=incomingLine.mid(pos+1);
  }

  // Find end of command
  pos=incomingLine.find(' ');
  // Copy command (all lowercase to make parsing easier)
  QString command=incomingLine.left(pos).lower();
  // Are there parameters left in the string?
  QStringList parameterList;
  if(pos!=-1)
  {
    // Cut out the command
    incomingLine=incomingLine.mid(pos+1);
    // The rest of the string will be the parameter list
    parameterList=QStringList::split(" ",incomingLine);
  }
  // Server command, if no "!" was found in prefixifif
   if (prefix.find('!')==-1 ) {
	ircM.isUserCommand=false;
	// parseServerCommand(prefix,command,parameterList,trailing);
	ircM.sCommand=command;
   } else {

      ircM.isUserCommand=true;
      ircM.sNick=prefix.mid(0,prefix.find("!"));
      prefix=prefix.mid(prefix.find("!")+1);
      ircM.sUser=prefix.mid(0,prefix.find("@"));
      prefix=prefix.mid(prefix.find("@")+1);
      ircM.sHost=prefix;
      // parseClientCommand(prefix,command,parameterList,trailing);
      ircM.sCommand=command;
   }
   qWarning("Nick: "+ircM.sNick+" User: "+ircM.sUser+" Host:"+ircM.sHost+"\n");
   qWarning("Command: "+ircM.sCommand+"\n");
}
