/***************************************************************************
                          kmilogic.h  -  description
                             -------------------
    begin                : Son Jun 16 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMILOGIC_H
#define KMILOGIC_H

#include <qobject.h>
#include <qregexp.h>
#include <qdatetime.h>
#include <klocale.h>
#include <kdebug.h>
#include "returncodes.h"
#include "../ircgui/kmichannelwindow.h"
#include "../logic/kmictcpparser.h"
#include "../logic/kmictcphandler.h"
#include "../logic/kmiinputcommand.h"
#include "../logic/kmioutputrender.h"
#include "../logic/kmiircmessage.h"


/**
  *@author Stephan Hermann
  */
class KMILogic : public QObject   {
  Q_OBJECT
public: 
	KMILogic(QObject *parent=0,const char *name=0,KMIOutputRender *_renderOutput=0,KMICTCPHandler *ctcp=0,KMIInputCommand *commandHandler=0);
	~KMILogic();  
  /** No descriptions */
  void doLogin(const QString &nickNName,const QString &userName,int mode,const QString &server, const QString &realName);
private: // Private attributes
  /**  */
  QString inputLine;
  /**  */
  QRegExp * returnCodes;
  /**  */
  bool beginMotd;
  /**  */
  QString motd;
  /**  */
  QString serverIdent;
  /**  */
  bool beginWhois;
  /**  */
  QString tempOutput;
  /**  */
  QRegExp * returnCommands;
  /**  */
  QString myIdentification;
  /**  */
  QString myNick;
  /**  */
  bool inJoinProcess;
  /**  */
  KMICTCPHandler * ctcpHandler;
  /**  */
  bool inLogin;
  /**  */
  KMIInputCommand * command;
  /**  */
  KMIOutputRender * renderOutput;
  /**  */
  bool inUsers;

public slots: // Public slots
  /** No descriptions */
  virtual void parseIncomingData(const QString &);
public slots: // Public slots
  /** No descriptions */
  virtual void parseInputCommands(const QString &,QWidget *);
  /** No descriptions */
  const QString & getServerIdent();
  /** No descriptions */
  const QString & getOwnNick();
signals: // Signals
  /** No descriptions */
  void sendInputToView(const QString &);
signals: // Signals
  /** No descriptions */
  void sendCommand(const QString &);
  /** No descriptions */
  void sendMotdToView(const QString &,const QString &);
  /** No descriptions */
  void connectionEstablished(const QString &);
  /** No descriptions */
  void channelJoin(const QString &);
  /** No descriptions */
  void addUserToList(const QString &,const QString &);
  /** No descriptions */
  void sendOutputToChannel(const QString &,const QString &);
  /** No descriptions */
  void sendSetOperatorStatus(const QString &,const QString &);
  /** No descriptions */
  void sendRemoveOperatorStatus(const QString &,const QString &);
  /** No descriptions */
  void sendSetVoice(const QString &,const QString &);
  /** No descriptions */
  void sendRemoveVoice(const QString &,const QString &);
  /** No descriptions */
  void sendSetNoMessagesFromOutside(const QString &,bool);
  /** No descriptions */
  void sendSetModerated(const QString &,bool);
  /** No descriptions */
  void setNickName(const QString &);
  /** No descriptions */
  void nickChanged(const QString &,const QString &);
  /** No descriptions */
  void closeChannelWindow(const QString &);
  /** No descriptions */
  void removeUserFromChannel(const QString &,const QString &);
  /** No descriptions */
  void sendSetAnonymous(const QString &,bool);
  /** No descriptions */
  void sendSetTopicProtection(const QString &,bool);
  /** No descriptions */
  void sendPrivateMessageFrom(const QString &,const QString &,const QString &);
  /** No descriptions */
  void sendSetInviteOnly(const QString &,bool);
  /** No descriptions */
  void sendSetQuite(const QString &,bool);
  /** No descriptions */
  void sendSetServerReOp(const QString &,bool);
  /** No descriptions */
  void sendSetSecret(const QString &,bool);
  /** No descriptions */
  void sendSetPrivate(const QString &,bool);
  /** No descriptions */
  void sendChannelLimit(const QString &,bool,const QString &);
  /** No descriptions */
  void sendChannelKey(const QString &,bool,const QString &);
  /** No descriptions */
  void sendNickAlreadyInUse();
  /** No descriptions */
  void setQuitMessage(const QString &,const QString &);
  /** No descriptions */
  void sendSetTopic(const QString &,const QString &);
  /** No descriptions */
  void sendPrivmsgToChannel(const QString &,const QString &,const QString &);
  /** No descriptions */
  void sendAction(const QString &,const QString &,const QString &);
  /** No descriptions */
  void sendNotice(const QString &,const QString &,const QString &);
  /** No descriptions */
  void sendNickChange(const QString &,const QString &,const QString &);
  /** No descriptions */
  void sendUserModeChange(const QString &,const QString &);
  /** No descriptions */
  void removeUserFromChannels(const QString &,const QString &);
  /** No descriptions */
  void sendChannelModeChange(const QString &,const QString &);
  /** No descriptions */
  void sendErrorMessage(const QString &,const QString &, const QString &);
  /** No descriptions */
  void sendNameReply(const QString &);
  /** No descriptions */
  void sendMsgToChannel(const QString &,const QString &,const QString &);
  /** No descriptions */
  void sendWhois(const QString &,const QString &);
  /** No descriptions */
  void sendAway(const QString &,const QString &);
  /** No descriptions */
  void sendWho(const QString &,const QString &);
  /** No descriptions */
  void sendUsers(const QString &,const QString &);
  /** No descriptions */
  void sendKickMessage(const QString &,const QString &);
  /** No descriptions */
  void sendInviteMessage(const QString &,const QString &);
  /** No descriptions */
  void sendLUserMsg(const QString &,const QString &);
  /** No descriptions */
  void sendVersionMsg(const QString &,const QString &);
  /** No descriptions */
  void sendListMsg(const QString &,const QString &,const QString &);
  /** No descriptions */
  void sendStatsLinkInfo(const QString &,const QString &);
  /** No descriptions */
  void sendStatsCommand(const QString &,const QString &);
  /** No descriptions */
  void sendStatsUptime(const QString &,const QString &);
  /** No descriptions */
  void sendStatsOLine(const QString &,const QString &);
  /** No descriptions */
  void sendEndOfStats(const QString &,const QString &);
  /** No descriptions */
  void sendEndOfLinksMsg(const QString &,const QString &);
  /** No descriptions */
  void sendLinksMsg(const QString &,const QString &);
  /** No descriptions */
  void sendTimeMsg(const QString &,const QString &);
  /** No descriptions */
  void sendTraceMsg(const QString &,const QString &);
  /** No descriptions */
  void sendAdminMsg(const QString &,const QString &);
  /** No descriptions */
  void sendInfoMsg(const QString &,const QString &);
  /** No descriptions */
  void sendServListMsg(const QString &,const QString &);
private: // Private methods
  /** No descriptions */
  bool parseReturnCodes(const uint &code,const QString &message);
  /** No descriptions */
  bool parseReturnCommands(const QString &from,const QString &command,const QString &message);
  /** No descriptions */
  QString getNickName(const QString &from);
  /** No descriptions */
  QString parseCtcpMessage(const QString &from,const QString &message);
  /** No descriptions */
  void setChannelModes(const QString &command,const QString &_from,const QString &_channel,const QString &_modes,const QString &_nicks);
  /** No descriptions */
  void parseUserModes(const QString &from,const QString &modes);
};

#endif
