/***************************************************************************
                          kmioutputrender.cpp  -  description
                             -------------------
    begin                : Mit Jul 3 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kmioutputrender.h"

KMIOutputRender::KMIOutputRender(QObject *parent,const char *name,KMIConfig *config,bool withColors):QObject(parent,name){
  cfg=config;
  mircColors=withColors;
}
KMIOutputRender::~KMIOutputRender(){
}
/**
  Found in kopete 0.4/ircmessage.cpp
  Only for testing this code...I think I can make it easier to work ;)
  
*/
QString KMIOutputRender::replaceSpecialChars(const QString &text){

  QString temp=QStyleSheet::escape(text);
  bool boldOn=false;
  bool colorOn=false;
  bool underlineOn=false;
  bool unterminatedColor=false;
  
  for (uint i=0;i!=temp.length();i++) {
    switch(QChar(temp[i].unicode())) {
      case 2: { // bold
        if (boldOn) {
          temp.remove(i, 1);
          temp.insert(i, "</b>");
          boldOn=false;
        } else {
          temp.remove(i,1);
          temp.insert(i,"<b>");
          boldOn=true;
        }
        break;
      }
      case 3: { // mIrc Colors
        temp.remove(i, 1);
        if (unterminatedColor == true) {
          temp.insert(i, "</font>");
          unterminatedColor = false;
          if (!QChar(temp[i]).isNumber()) {
            continue;
          }
        }
        // Colors! Or colours for you freaks out there ;)
        QString code;
        if (QChar(temp[i + 1]).isNumber())
        {
          code = temp[i];
          code.append(temp[i + 1]);
          temp.remove(i, 2);
        } else {
          code = temp[i];
          temp.remove(i, 1);
        }
        switch (code.toUInt()) {
          case 0: {
            temp.insert(i, "<font color=#FFFFFF>");
            unterminatedColor = true;
            break;
          }
          case 1: {
            temp.insert(i, "<font color=#000000>");
            unterminatedColor = true;
            break;
          }
          case 2:
          {
            temp.insert(i, "<font color=#00008C>");
            unterminatedColor = true;
            break;
          }
          case 3:
          {
            temp.insert(i, "<font color=#006400>");
            unterminatedColor = true;
            break;
          }
          case 4:
          {
            temp.insert(i, "<font color=#E60000>");
            unterminatedColor = true;
            break;
          }
          case 5:
          {
            temp.insert(i, "<font color=#960000");
            unterminatedColor = true;
            break;
          }
          case 6:
          {
            temp.insert(i, "<font color=#500050>");
            unterminatedColor = true;
            break;
          }
          case 7:
          {
            temp.insert(i, "<font color=#FF5A00>");
            unterminatedColor = true;
            break;
          }
          case 8:
          {
            temp.insert(i, "<font color=#FFFF00>");
            unterminatedColor = true;
            break;
          }
          case 9:
          {
            temp.insert(i, "<font color=#00FF00>");
            unterminatedColor = true;
            break;
          }
          case 10:
          {
            temp.insert(i, "<font color=#0096B4>");
            unterminatedColor = true;
            break;
          }
          case 11:
          {
            temp.insert(i, "<font color=#AAAAFF>");
            unterminatedColor = true;
            break;
          }
          case 12:
          {
            temp.insert(i, "<font color=#0F0FFF>");
            unterminatedColor = true;
            break;
          }
          case 13:
          {
            temp.insert(i, "<font color=#C800C8>");
            unterminatedColor = true;
            break;
          }
          case 14:
          {
            temp.insert(i, "<font color=#505050>");
            unterminatedColor = true;
            break;
          }
          case 15:
          {
            temp.insert(i, "<font color=#AAAAAA>");
            unterminatedColor = true;
            break;
          }
        }
        break;
      }
      case 31: { // Underline
        if (underlineOn) {
          temp.remove(i,1);
          temp.insert(i,"</u>");
          underlineOn=false;
        } else {
          temp.remove(i,1);
          temp.insert(i,"<u>");
          underlineOn=true;
        }
        break;
      }
    }
  }

  // Render URLs
#if KDE_VERSION >= 305
  temp=KStringHandler::tagURLs(temp);
#else
  temp=tagURLs(temp);
#endif
  return temp;
}
/** No descriptions */
QString KMIOutputRender::renderOutput(uint ircReplyCode,const QDict<QString> &stringsToReplace) {
  QString outputString;
  QString replyCode=QString("").sprintf("%03d",ircReplyCode);
  QString outputStr=cfg->findMessageText(replyCode);
  qWarning("ReplyCode: %03d ",ircReplyCode);
  if (outputStr.isEmpty()) {
    outputStr=cfg->findMessageText("DEFAULT");
  }
  QDictIterator<QString> it(stringsToReplace);
  for( ; it.current(); ++it ) {
    QString temp=replaceSpecialChars(*it.current());
    outputStr.replace(QRegExp("\\<\\!-- "+it.currentKey()+" --\\>"),temp);
  }
  QString color=cfg->findColor(replyCode);
  outputString=QString("<font color=\""+color+"\">");
  if (cfg->getGlobals()->showTime!=0) {
    renderDateTime();
    outputString=outputString+"["+dateTimeString+"] ";
  }
  //if (outputStr.find(cfg->getGlobals()->highlightPhrase)!=-1) {
  //  qDebug("gefunden");
    // outputStr.replace(QRegExp(cfg->getGlobals()->highlightPhrase),"<font color=\"#ff9900\">"+cfg->getGlobals()->highlightPhrase+"</font>");
  //  outputStr.replace(QRegExp("[^\\<]"+cfg->getGlobals()->highlightPhrase+"[^\\>]"),"<font color=\"#ff9900\">"+cfg->getGlobals()->highlightPhrase+"</font>");
  //}
  
  outputString=outputString+outputStr+"</font>";
  // outputStr=QString("<font color=\"%1\">%2</font>").arg(color).arg(outputStr);
  return outputString;
}
/** No descriptions */
QString KMIOutputRender::renderOutput(const QString &ircReplyCommand,const QDict<QString> &stringsToReplace) {
  QString outputString;
  QString outputStr=cfg->findMessageText(ircReplyCommand);
  QDictIterator<QString> it(stringsToReplace);
  QString color=cfg->findColor(ircReplyCommand);
  bool highlight=false;
  for( ; it.current(); ++it ) {
    QString temp=replaceSpecialChars(*it.current());
    if (temp.contains(cfg->getGlobals()->highlightPhrase,false)==true && it.currentKey()=="msg" && ircReplyCommand.lower()=="privmsg") {
      highlight=true;
    }
    outputStr.replace(QRegExp("\\<\\!-- "+it.currentKey()+" --\\>"),temp);
  }
  if (highlight) {
    color=cfg->findColor("HIGH_"+ircReplyCommand);
  } 
  outputString=QString("<font color=\""+color+"\">");
  if (cfg->getGlobals()->showTime!=0) {
    renderDateTime();
    outputString=outputString+"["+dateTimeString+"] ";
  }
  outputString=outputString+outputStr+"</font>";  
  //outputStr=QString("<font color=\"%1\">%2</font>").arg(color).arg(outputStr);
  return outputString;
}

/** No descriptions */
void KMIOutputRender::renderDateTime(){
  dateTime=QDateTime::currentDateTime();
    if (cfg->getGlobals()->showTime!=0) {
        if (cfg->getGlobals()->showTime==1) {
		dateTimeString=dateTime.toString("hh:mm:ss");
        }
        if (cfg->getGlobals()->showTime==2) {
          // To be implemented
          dateTimeString=dateTime.toString("MM/dd/yyyy hh:mm:ss");
        }
    }
}


/** No descriptions */
QString KMIOutputRender::tagURLs(const QString &text){

  // QRegExp urlEx("(www\\.|(f|ht)tp(|s)://)[\\d\\w./,:_~\\?=&;#-]+[\\d\\w/]");
  // Changed 20020709 St. Hermann <sh@kde-coder.de>
  // Logical bug in regexp.
  // if regexp is matching www. (and/or added ftp. ,too) without a protocol,
  // we must ensure that we aren't exploring the filesystem.
  // QRegExp urlEx("(?:www\\.|ftp\\.|\\w+://)[\\d.\\w.\\.\\/][\\.:_~\\?\\=&;\\#\\-]+[\\d\\w\\/]+");
  QRegExp urlEx("(?:www\\.|ftp\\.|\\w+\\://)[\\/\\d\\w\\.\\-]+[:\\d+]?[/]?[~/\\.-?&=#:_\\d\\w]*");
  QString richText( text );
  int urlPos = 0, urlLen;
  while ((urlPos = urlEx.search(richText, urlPos)) >= 0)
  {
    urlLen = urlEx.matchedLength();
    QString href = richText.mid( urlPos, urlLen );
    QString hrefProtocol;
    QString anchor;
    if (href.startsWith("www.")) {
      hrefProtocol="http://"+href;
    } else if (href.startsWith("ftp.")) {
      hrefProtocol="ftp://"+href;
    } else {
      hrefProtocol=href;
    }
    anchor = "<a href=\""+hrefProtocol+"\">"+href+"</a>";
    richText.replace( urlPos, urlLen, anchor );
    urlPos += anchor.length();
  }
  return richText;
}
