/***************************************************************************
                          kmioutputrender.h  -  description
                             -------------------
    begin                : Mit Jul 3 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMIOUTPUTRENDER_H
#define KMIOUTPUTRENDER_H

// QT Includes
#include <qobject.h>
#include <qstylesheet.h>
#include <qregexp.h>
#include <qstringlist.h>
#include <qdatetime.h>
#include <kdeversion.h>
#if KDE_VERSION >= 305
  #include <kstringhandler.h>
#endif


// KDE Includes

// Local Includes
#include "../logic/kmiconfig.h"

/**
  *@author Stephan Hermann
  */

class KMIOutputRender : public QObject  {
  Q_OBJECT
public:
  enum MsgType {
    NORMAL = 0,
    MOTD = 1,
    CTCP_ACTION = 2,
    ChannelMODES = 4,
    NOTICE = 8,
    NICK = 16,
    UserMODES = 32,
    ErrorMsg = 64,
    Msg = 128
  };
	KMIOutputRender(QObject *parent=0,const char *name=0,KMIConfig *config=0,bool withColors=true);
	~KMIOutputRender();
  /** No descriptions */
  QString replaceSpecialChars(const QString &);
  /** No descriptions */
  QString renderOutput(uint ircReplyCode,const QDict<QString> &stringsToReplace);
  /** No descriptions */
  QString renderOutput(const QString &ircReplyCommand,const QDict<QString> &stringsToReplace);
private: // Private attributes
  /**  */
  KMIConfig * cfg;
  /**  */
  bool mircColors;
  /**  */
  QDateTime dateTime;
  /**  */
  QString dateTimeString;
private: // Private methods
    /** No descriptions */
    void renderDateTime();

  /** No descriptions */
  QString tagURLs(const QString &);
};

#endif
