/***************************************************************************
                          structures.h  -  description
                             -------------------
    begin                : Son Jun 23 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef STRUCTURES_H
#define STRUCTURES_H

// QT Includes
#include <qdict.h>
#include <qcolor.h>
#include <qptrlist.h>
#include <qstringlist.h>
#include <qmap.h>

struct s_Globals {
  QString mainNickname;
  QString altNickname;
  QString realName;
  QString userName;
  bool isInvisible;
  bool receiveWallOps;
  bool noServerListAtStartUp;
  uint showTime;
  QString highlightPhrase;
};

struct serverItem {
  QString group;;
  QString name;
  QString serverName;
  uint portNo;
};

typedef QPtrList<serverItem> serverList;

struct s_msgColors {
  QString msgType;
  QColor msgColor;
};

typedef QPtrList<s_msgColors> colorList;

struct s_msgText {
  QString msgType;
  QString msgText;
};

typedef QPtrList<s_msgText> textList;

struct s_channelUser {
  QString nickName;
  QString address;
  bool hasOp;
  bool hasVoice;
};

typedef QMap<uint,s_channelUser> l_channelUserlist;

struct s_aliasList {
  QString aliasName;
  QString aliasCommands;
  int ofType;
};

typedef QPtrList<s_aliasList> l_aliasCmdList;

struct s_ircMessage {
	bool isUserCommand;
	QString sNick;
  QString sUser;
  QString sHost;
  QString sCommand;
  QStringList parameters;
 };
 
typedef s_ircMessage t_ircMessage;
 
#endif
