/***************************************************************************
                          kminetworkclient.cpp  -  description
                             -------------------
    begin                : Son Jun 16 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "../network/kminetworkclient.h"
#include <kapp.h>

KMINetworkClient::KMINetworkClient(QObject *parent,const char *name):QObject(parent,name){
  sock=new QSocket(this);
  connect(sock,SIGNAL(connected()),this,SLOT(isConnect()));
  connect(sock,SIGNAL(readyRead()),this,SLOT(slotReceivedNetworkPacket()));
  connect(sock,SIGNAL(connectionClosed()),this,SLOT(slotConnectionClosed()));
  connect(sock,SIGNAL(error(int)),this,SLOT(slotSocketError(int)));
  resultReady=false;
  connectionClosed=false;
  _isConnected=false;
}
KMINetworkClient::~KMINetworkClient(){
}
/** No descriptions */
void KMINetworkClient::connectToHost(const QString &host,const QString &port){
  sock->connectToHost(host,port.toUInt());
}
/** No descriptions */
void KMINetworkClient::isConnect(){
  _isConnected=true;
  connectedToServer();
}
/** No descriptions */
bool KMINetworkClient::isConnected(){
  return _isConnected;
}
/** No descriptions */
void KMINetworkClient::slotReceivedNetworkPacket(){
  QString buffer;
  while(sock->canReadLine()) {
    buffer=sock->readLine();
    buffer=buffer.replace(QRegExp("\r\n"),"");
    // qWarning(buffer);
    sendOutputToView(buffer);
    processData(buffer);
  }
}

/** No descriptions */
void KMINetworkClient::sendNetworkPacket(const QString &data){
  // qWarning(data);
  // qDebug("Sender %s",sender()->name());
  // qDebug("data: "+data);
  sock->writeBlock(data.latin1(),data.length());
  sock->flush();
  qDebug("Error: %d",sock->socketDevice()->error());
  qDebug("Status: %d",sock->state());
}
/** No descriptions */
const QString & KMINetworkClient::getOwnHostname(){
  QDns *dns=new QDns(sock->address(),QDns::Ptr);
  connect(dns,SIGNAL(resultsReady()),this,SLOT(dnsResultReady()));
  while (!resultReady) {
    kapp->processEvents();
  }
  QStringList list = dns->hostNames();
  QStringList::Iterator it = list.begin();
  ownHostname=*it;
  return ownHostname;
  delete dns;
}
/** No descriptions */
void KMINetworkClient::dnsResultReady(){
  resultReady=true;
}
/** No descriptions */
void KMINetworkClient::slotConnectionClosed(){
  connectionClosed=true;
}
/** No descriptions */
bool KMINetworkClient::isConnectionClosed(){
  return connectionClosed;
}
/** No descriptions */
void KMINetworkClient::slotSocketError(int errorCode){
  switch(errorCode) {
    case QSocket::ErrConnectionRefused: {
        qDebug("NetworkClient: ConnectionRefused");
        break;
    }
    case QSocket::ErrHostNotFound: {
      qDebug("NetworkClient: Host Not Found !");
      break;
    }
    case QSocket::ErrSocketRead: {
      qDebug("NetworkClient: Error Socket Reading");
      break;
    }
    default: {
      qDebug("ErrorCode: %d",errorCode);
      break;
   }
  }
}
