/***************************************************************************
                          kminetworkclient.h  -  description
                             -------------------
    begin                : Son Jun 16 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMINETWORKCLIENT_H
#define KMINETWORKCLIENT_H

// QT Includes
#include <qobject.h>
#include <qsocket.h>
#include <qsocketdevice.h>
#include <qcstring.h>
#include <qdns.h>
#include <qregexp.h>



/**
  *@author Stephan Hermann
  */

class KMINetworkClient : public QObject  {
  Q_OBJECT
public: 
	KMINetworkClient(QObject *parent=0,const char *name=0);
	~KMINetworkClient();
  /** No descriptions */
  void connectToHost(const QString &host,const QString &port);
  /** No descriptions */
  bool isConnected();
  /** No descriptions */
  const QString & getOwnHostname();
  /** No descriptions */
  bool isConnectionClosed();
private: // Private attributes
  /**  */
  bool _isConnected;
  /**  */
  QString ownHostname;
  /**  */
  bool resultReady;
  /**  */
  QSocket * sock;
  /**  */
  bool connectionClosed;
  
signals: // Signals
  /** No descriptions */
  void connectedToServer();
private slots: // Private slots
  /** No descriptions */
  void isConnect();
  /** No descriptions */
  void slotReceivedNetworkPacket();
signals: // Signals
  /** No descriptions */
  void sendOutputToView(const QString &);
private: // Private methods
  /** No descriptions */


public slots: // Public slots
  /** No descriptions */
  void sendNetworkPacket(const QString &);
  /** No descriptions */
  void dnsResultReady();
signals: // Signals
  /** No descriptions */
  void processData(const QString &);
protected slots: // Protected slots
  /** No descriptions */
  virtual void slotConnectionClosed();
protected slots: // Protected slots
  /** No descriptions */
  virtual void slotSocketError(int);
};

#endif
