/***************************************************************************
                          kmiinputline.cpp  -  description
                             -------------------
    begin                : Mit Jun 26 2002
    copyright            : (C) 2002 by Stephan Hermann
    email                : sh@sourcecode.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "../kmiwidgets/kmiinputline.h"

KMIInputLine::KMIInputLine(QWidget *parent, const char *name ) : QLineEdit(parent,name) {
  strList=new QStringList();
  current=strList->end();
	connect(this,SIGNAL(returnPressed()),SLOT(slotInputReturnPressed()));
}

KMIInputLine::~KMIInputLine(){
  delete strList;
}

void KMIInputLine::slotInputReturnPressed() {
    strList->append(text());
    if (strList->count()>25) {
      strList->remove(strList->begin());
    }
    current=strList->end();
}
/** No descriptions */
void KMIInputLine::keyPressEvent(QKeyEvent *e){
  if (e->key()==Key_Return || e->key()==Key_Enter) {
    strList->append(text());
    if (strList->count()>25) {
      strList->remove(strList->begin());
    }
    current=strList->end();
  }
  if (e->key()==Key_Up && current!=strList->begin()) {
    --current;
    setText(*current);
    e->accept();
  } else if (e->key()==Key_Down && current!=strList->end()) {
    ++current;
    setText(*current);
    e->accept();
  }          
  QLineEdit::keyPressEvent(e);
}
